#include <avr/io.h>
#include <stdlib.h>
#include <string.h>
#include <util/delay.h>
#include <math.h>
int i;
uint16_t read_adc(uint8_t channel)
{
    ADMUX = 0b01000000; // เลือกใช้แรงดันอ้างอิงจากขา AREF
    ADMUX |= channel;   // ตั้ง MUX ให้ชี้ไปยัง channel
    ADCSRA = 0b11000110;
    //         ||   -+-
    //         ||    |
    //         ||    +-> ปรับคล็อกของ ADC ให้เป็น 1/64 ของคล็อกระบบ
    //         |+->เริ่มแปลงค่าแอนะล็อกเป็นดิจิทัล (บิต ADSC)
    //         |
    //         +-> Enable ADC (บิต ADEN)

    while ((ADCSRA & (1<<ADSC))) // รอจนบิต ADSC (บิต 6) กลายเป็น 0
        ;
    return ADCL + ADCH*256;  // ผลลัพธ์ถูกเก็บอยู่ในรีจีสเตอร์ ADCL และ ADCH
}
void out_seg(char b1,char b2){
	if(i % 2){PORTB = 0b00010000;PORTB |= b1;}
	 else{PORTB = 0b00100000;PORTB |= b2;}	
}
int main(void) {
	DDRB = 0b01111111;
	i = 1;
	char b1,b2;
	double k,a1,r2,rin;
	int T;
	while(1){
		k = read_adc(0);
		a1 = k/1024;
		r2 = (pow(10,4)-(a1*pow(10,4)))/a1;
		rin = pow(10,4)*pow(M_E,(-3950.0/298));
		T = (3950.0/((log(r2))-(log(rin))))-273;
		out_seg(T%10,T/10);
		i++;
		_delay_ms(5);
	}
}
